<template>
    <div>
        <div class="hidden">
            <input type="text" name="content" v-model="json">
        </div>
        <div>
            <editor-content :editor="editor" />
        </div>
    </div>
</template>

<script>
    import { Editor, EditorContent } from 'tiptap';
    import Limit from "./extensions/Limit";

    export default {
        name: "CommentEditorComponent",
        components: {
            EditorContent,
        },
        props: ["value", "content"],
        data() {
            return {
                editor: null,
                editorChange: false,
                json: null
            };
        },
        mounted() {

            if (this.content != null)
            {
                this.editor = new Editor({
                    onUpdate: ({ getJSON }) => {
                        this.editorChange = true;
                        this.$emit("input", getJSON());

                        this.json = JSON.stringify(getJSON())
                    },
                    content: JSON.parse(this.content),
                    extensions: [
                        new Limit({
                            limit: 200
                        }),
                    ],
                });
            } else {
                this.editor = new Editor({
                    onUpdate: ({ getJSON }) => {
                        this.editorChange = true;
                        this.$emit("input", getJSON());

                        this.json = JSON.stringify(getJSON())
                    },
                    extensions: [
                        new Limit({
                            limit: 200
                        }),
                    ],
                });
            }
        },
        beforeDestroy() {
            this.editor.destroy()
        },
        watch: {
            value(val) {

                if (this.editor && !this.editorChange) {
                    this.editor.setContent(val, true);
                }
                this.editorChange = false;
            }
        }
    }
</script>
